//
// C++ Interface: columnselectdialog
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef COLUMNSELECTDIALOG_H
#define COLUMNSELECTDIALOG_H

#include <QDialog>
class QAbstractItemModel;
class QStandardItemModel;
class QListView;

/**
	@author Arne Schmitt <arne@as4m.de>
*/
class ColumnSelectDialog : public QDialog
{
Q_OBJECT
public:
    ColumnSelectDialog(QWidget* parent=0, Qt::WindowFlags f=0);

    ~ColumnSelectDialog();
    static QVector<int> getColumnList(QAbstractItemModel *model);
    static int getColumn(QAbstractItemModel *model);
    void setModel(QAbstractItemModel *m);
    void setMarks(const QVector<int>& marks);
    QList<int> columns();
    
protected:
	QStandardItemModel *spmodel;
	QAbstractItemModel *model;
	QListView *lv;
	
protected slots:
    void updateList();
};

#endif
