//
// C++ Implementation: lineareregression
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "lineareregression.h"
#include <numeric>
#include <QPainter>
#include <QtDebug>

LineareRegression::LineareRegression(QWidget* parent): XYPlotter(parent)
{
}


LineareRegression::~LineareRegression()
{
}


void LineareRegression::paint(QPainter& p)
{
	int x0=15;
	int y0=height()-5;
	
	const double mx = std::accumulate(sx.begin(),sx.end(),0.0)/sx.size();
	const double my = std::accumulate(sy.begin(),sy.end(),0.0)/sy.size();
	
	double s1 = 0.0,s2 = 0.0;
	for(int i=0;i<sx.count();++i)
	{
		s1 += (sx[i]-mx) * (sy[i]*my);
		s2 += (sx[i]-mx) * (sx[i]-mx);
	}
	
	const double m = s1/s2;
	const double a = my - m*mx;
	
	int x1 = 15+minX;
	int x2 = width()-15;
	int y1= height()-15-(a)*scY;
	int y2= height()-15-((maxX-minX)*m+a)*scY;
	
	p.setPen(QPen(Qt::red,5));
	p.drawLine(x1,y1,x2,y2);
	p.setPen(Qt::black);
	QString msg;
	if(a>0) msg = "y=%1x+%2"; else msg="y=%1x-%2";
	p.drawText(width()/2-40,height()/2-40,msg.arg(m).arg(a));
}

